function learning_set = DataShuffling(train_set)
    % Data Shuffling
    % input argument: the input set 'train_set'
    % output argument: the output set 'learning_set'
    
    Nts = size(train_set, 1); % the number of train-set samples
    p = transpose(randperm(Nts)); % random permutation 
    learning_set = zeros(Nts, size(train_set, 2));
    
    for k = 1:1:Nts
        learning_set(k, :) = train_set(p(k, 1), :); % shuffling of train-set 
    end
    
end

