function fp = PostProcess(f, M)
    % Post Processing
    % input arguments: the image 'f' and the sampling mask 'M'
    % output argument: the post-processed image 'fp'
    
    [h, w] = size(f);
    sig_f = 1.5; 
    Wfilter = 3; % % size of square window
    rho = 0.3; 
    Kernel = fspecial('gaussian', [Wfilter, Wfilter], sig_f);
    
    Kernel = Kernel(:)';
    Wh = floor(Wfilter/2);
    % ************************* Preallocation *****************************
    fsi = zeros(1, Wfilter*Wfilter);
    fp = f;
    % *********************************************************************
    for r = 1:1:h
        for c = 1:1:w
            temp = 1;
            M_wind = zeros(Wfilter, Wfilter); 
            for rw = -Wh:1:Wh
                for cw = -Wh:1:Wh
                    ii = r + rw;
                    jj = c + cw;

                    if ii < 1              
                        ii = 1;
                    elseif ii > h
                        ii = h;
                    end % end of if ii 
                    if jj < 1              
                        jj = 1;
                    elseif jj > w
                        jj = w;
                    end % end of if jj
                    
                    M_wind(rw+ceil(Wfilter/2), cw+ceil(Wfilter/2)) = M(ii, jj);
                    
                    fsi(temp) = f(ii, jj);
                    temp = temp + 1;
                end
            end
            
            if length(find(M_wind(:) == 1)) < round(rho*(Wfilter*Wfilter)) 
                fp(r, c) = sum(fsi.*Kernel);
            end
            clear M_wind 
            
        end
    end
    % *********************************************************************

end

