function [Img, Smask, Irec] = cropping(Img, Smask, Irec, rm)
    % cropping
    % input arguments:
    % the original padded image 'Img'
    % the sampling mask 'Smask'
    % the recovered image 'Irec'
    % the vector 'rm' representing the amount of padding
    % output arguments:
    % the cropped original image 'Img'
    % the cropped sampling mask 'Smask'
    % the cropped recovered image 'Irec'
    
    [d1, d2] = size(Img);
    
    Irec = Irec(1:d1-rm(1), 1:d2-rm(2));
    Img = Img(1:d1-rm(1), 1:d2-rm(2));
    Smask = Smask(1:d1-rm(1), 1:d2-rm(2));

end

