function [Izp, rm] = zeropadding(I)
    % zero padding
    % input argument: the input image 'I'
    % output arguments: the zero padded image 'Izp' and the vector 'rm' representing the amount of padding
    
    [d1, d2, ~] = size(I);
    
    b = 8; % the patch length
    
    s = [d1, d2];
    rm = zeros(2, 1);
    for d = 1:2
        l = s(d);
        c = l/b;
        fp = c - floor(c);
        if fp ~= 0
            rm(d) = (1 - fp)*b;
            s(d) = s(d) + rm(d);
        end
    end
    
    Izp = padarray(I, rm, 'post');

end

